--- old/usr/src/lib/udapl/libdat/common/dat_dictionary.c	Thu Jan 17 14:48:54 2019
+++ new/usr/src/lib/udapl/libdat/common/dat_dictionary.c	Thu Jan 17 14:48:54 2019
@@ -28,7 +28,9 @@
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
+/*
+ * Copyright (c) 2018, Joyent, Inc.
+ */
 
 /*
  *
@@ -144,8 +146,6 @@
 bail:
 	if (DAT_SUCCESS != status) {
 		if (NULL != p_dictionary) {
-			dat_os_free(p_dictionary, sizeof (DAT_DICTIONARY));
-
 			if (NULL != p_dictionary->head) {
 				dat_os_free(p_dictionary->head,
 				    sizeof (DAT_DICTIONARY_NODE));
@@ -155,7 +155,10 @@
 				dat_os_free(p_dictionary->tail,
 				    sizeof (DAT_DICTIONARY_NODE));
 			}
+
+			dat_os_free(p_dictionary, sizeof (DAT_DICTIONARY));
 		}
+
 	}
 
 	return (status);
